80286.TAB/
	MOTOROLA

; Table param disquettes charge en $7C3E

	SEGMENT Byte at 7C3E 'RamCode'
	DS.B	;00 7C3E	First specify byte
		;	bits 7-4: step rate
		;	bits 3-0: head unload time (0Fh = 240 ms)
	DS.B	;01 7C3F	Second specify byte
		;	bits 7-1: head load time (01h = 4 ms)
		;	bit    0: non-DMA mode (always 0)
	DS.B	;02 7C40	Delay until motor turned off (in clock ticks)
	DS.B	;03 7C41	Bytes per sector (00h = 128, 01h = 256, 02h = 512, 03h = 1024)
	DS.B	;04 7C42	Sectors per track
	DS.B	;05 7C43	Length of gap between sectors (2Ah for 5.25", 1Bh for 3.5")
	DS.B	;06 7C44	Data length (ignored if bytes-per-sector field nonzero)
	DS.B	;07 7C45	Gap length when formatting (50h for 5.25", 6Ch for 3.5")
	DS.B	;08 7C46	Format filler byte (default F6h)
	DS.B	;09 7C47	Head settle time in milliseconds
	DS.B	;0A 7C48	Motor start time in 1/8 seconds

NumSecDon	DS.L	;7C49	Numro premier secteur de donnes
NumPiste	DS.W	;7C4D
NumSect	DS.B	;7C4F
NumSecRep	DS.L	;7C50	Numro du premier secteur du rpertoire racine

	SEGMENT	byte at 7C00 'code'

	JMPS	PrgBoot
	NOP
	STRING	"MSDOS5.0"
NbOctSec:	WORD	$0200	;7C0B  Octets par secteur
NbSecGrp:	DC.B	$10	;Nombre de secteurs par groupe (clusters)
NbSecRes:	WORD	1	;Nombre de secteurs rservs
NbrFats:	DC.B	2	;Nombres de FATs
NbFicRep:	WORD	$0200	;Nombre d'entres dans rpertoire \
NbSecVol:	WORD	0	;Nombre de secteurs dans volume
TypeMedia:	DC.B	$F8	;Type de mdia : disque dur
NbSecFat:	WORD	$9D	;Nombre de secteurs par Fat
NbSecPis:	WORD	$0020	;Secteurs par pistes
NbTetes:	WORD	$0040	;Nombre de ttes
SecDebPar:	LONG	$00000020	;Nbre de secteurs entre dbut partition et disque
NbSecPart:	LONG	$0009C7E0	;Nbre de secteurs de la partition
NumDisque:	DC.B	$80
NumTete:	DC.B	0
	DC.B	$29
	LONG	$00000007	;Numro du volume

	STRING	"PASCAL'S1  "
	STRING	"FAT16   "

;--- Programme de boot proprement dit
PrgBoot:
	CLI
	XOR	AX,AX	;AX=0000
	MOV	SS,AX	;SS:SP = $0000:7C00
	MOV	SP,$7C00
	PUSH	SS
	POP	ES	;ES=0000
	MOV	BX,$0078	;SS:BX = ^0000:0078 = ^Vecteur INT 1E
	LDS	SI,SS:[BX]	;Rcupre Ptr sur param disquettes
	PUSH	DS	;Sauve pointeur sur param dskt originaux
	PUSH	SI
	PUSH	SS	;Sauve pointeur sur Vecteur int1E
	PUSH	BX

	MOV	DI,OFFSET PrgBoot	;Copie table Int1E
	MOV	CX,11		;en PrgBoot..PrgBoot+$10  !!!
	CLD
	REP MOVSB

	PUSH	ES	;DS=0000
	POP	DS
	MOV	-2[DI],15	;Delai chargement tte = 15 ms
	MOV	CX,[NbSecPis] ;Nombre secteurs par piste du disque act
	MOV	-7[DI],CL	;impose mme nbre de secteurs/piste

	MOV	2[BX],AX	;Vecteur INT 1E pointe sur table modifie
	MOV	[BX],OFFSET PrgBoot
	STI
	INT	$13	;AX=0 : init systme disquettes
	JC	NonSys	;Erreur Init Disquette

;--- Met nombre secteurs dans partition si pas dj prsent
	XOR	AX,AX	;Si nbr secteur dans volume <>0
	CMP	[NbSecVol],AX
	JE	DejaMis
	MOV	CX,[NbSecVol] ;alors le met dans nbr sect partition
	MOV	[NbSecPart],CX
DejaMis:

;--- Calcule n du premier secteur du rpertoire racine
	MOV	AL,[NbrFats]	;Calcule Taille occupe par fats
	MUL	WORD PTR [NbSecFat]
	ADD	AX,[SecDebPar]	;Ajoute N premier sect de partition
	ADC	DX,[SecDebPar+2]
	ADD	AX,[NbSecRes]	;Ajoute nbr sect rservs
	ADC	DX,0
	MOV	[NumSecRep],AX	;Num prem secteur du rpertoire racine
	MOV	[NumSecRep+2],DX

;--- Calcule n du premier secteur de donnes = NumSecRep+TailleRep
	MOV	[NumSecDon],AX	;Num prem sect rpertoire
	MOV	[NumSecDon+2],DX
	MOV	AX,$20		;Calcule taille du rpertoire racine
	MUL	WORD PTR [NbFicRep]	;en secteurs (arrondi  l'entier sup.)
	MOV	BX,[NbOctSec]
	ADD	AX,BX
	DEC	AX
	DIV	BX
	ADD	[NumSecDon],AX	;ajoute taille rpertoire
	ADC	[NumSecDon+2],0

;--- Charge 1ier secteur rpertoire, vrifie prsence IO.SYS et MSDOS.SYS
	MOV	BX,$0500		;Adresse du buffer
	MOV	DX,[NumSecRep+2]	;Convertit n prem sect rpertoire
	MOV	AX,[NumSecRep]	;en Piste/tete/Secteur
	CALL	ConvNumSec
	JB	NonSys

	MOV	AL,1		;Lit 1 secteur dans ES:BX
	CALL	LitSecteur
	JB	NonSys

	MOV	DI,BX		;ES:DI pointe dbut rpertoire
	MOV	CX,11		;Vrifie premier fichier est IO.SYS
	MOV	SI,OFFSET TxtIOSYS
	REP CMPSB
	JNE	NonSys

	LEA	DI,32[BX]		;Pointe seconde entre
	MOV	CX,11		;Vrifie second fichier est MSDOS.SYS
	REP CMPSB
	JE	ChargeIOSYS

;--- Erreur Affiche 'Disque non systme ...' et reboote.
NonSys:
	MOV	SI,OFFSET TxtNonSys
	CALL	AffChaine

	XOR	AX,AX	;Lit clavier avec attente si besoin
	INT	$16

	POP	SI	;Rcupre pointeur sur Vect INT 1E
	POP	DS
	POP	[SI]	;Remet ancienne table
	POP	2[SI]
	INT	$19	;Recommence boot
NonSys2:
	POP	AX	;Mme chose mais en librant place occupe
	POP	AX	;sur pile par sauvegarde registres
	POP	AX
	JMPS	NonSys

;--- Calcule N du premier secteur de IO.SYS
ChargeIOSYS:
	MOV	AX,$1A[BX]	;Rcupre numro 1ier groupe de IO.SYS
	DEC	AX	;2 premires entres de FAT = Desc. de support
	DEC	AX
	MOV	BL,[NbSecGrp]
	XOR	BH,BH
	MUL	BX
	ADD	AX,[NumSecDon]
	ADC	DX,[NumSecDon+2]

;--- Charge IO.SYS (3 premiers secteurs) en 0000:0700..0D00
	MOV	BX,$0700	;Buffer en ES:BX = 0000:0700 = 0070:0000
	MOV	CX,3	;Pour 3 secteurs
BclLoadIO:
	PUSH	AX	;Sauve N premier secteur de IO.SYS
	PUSH	DX
	PUSH	CX
	CALL	ConvNumSec
	JB	NonSys2
	MOV	AL,1
	CALL	LitSecteur
	POP	CX
	POP	DX
	POP	AX
	JB	NonSys

	ADD	AX,1	;Secteur suivant
	ADC	DX,0
	ADD	BX,[NbOctSec]	;Avance pointeur dans buffer
	LOOP	BclLoadIO

; Passe le contrle  IO.SYS
	MOV	CH,[TypeMedia]
	MOV	DL,[NumDisque]
	MOV	BX,[NumSecDon]
	MOV	AX,[NumSecDon+2]
	JMPF	$0070:$0000

;--- Affiche chaine AZT pointe par DS:SI
AffChaine:
	LODSB
	OR	AL,AL
	JE	c7D80c
	MOV	AH,$0E
	MOV	BX,$07
	INT	$10
	JMPS	AffChaine

;--- Convertit Numro de secteur(DX:AX) en Piste/Tete/Secteur
ConvNumSec:
	CMP	DX,[NbSecPis]	;Vrifie Numro de piste*Tete<$FFFF
	JAE	TropGrand
	DIV	WORD PTR [NbSecPis]	;Calcule numro de secteur (DX=Reste)
	INC	DL
	MOV	[NumSect],DL	;et le sauve

	XOR	DX,DX
	DIV	[NbTetes]
	MOV	[NumTete],DL	;Numro de tte
	MOV	[NumPiste],AX	;Numro de piste
	CLC
	RET
TropGrand:
	STC
c7D80c:
	RET

;--- Lecture de AL secteurs  partir de NumPiste/NumTete/NumSect dans ES:BX
LitSecteur:
	MOV	AH,2		;Lecture de secteur
	MOV	DX,[NumPiste]	;AL=Nbre de secteurs  lire
	MOV	CL,6		;CH=Numro de piste(cylindre)
	SAL	DH,CL		;CL=Numro de secteur + 2 bits piste
	OR	DH,[NumSect]
	MOV	CX,DX
	XCHG	CH,CL
	MOV	DL,[NumDisque]	;DL=Numro de disque
	MOV	DH,[NumTete]	;DH=Numro de tte
	INT	$13
	RET

TxtNonSys:
	STRING	0DH,0AH
	STRING	"Disque non-systme/erreur disque",0DH,0AH
	STRING	"Remplacez et pressez touche",0DH,0AH,0H

TxtIOSYS:	STRING	"IO      SYS"
	STRING	"MSDOS   SYS"

	DC.B	0H,0H,0H,0H	;Remplissage
	DC.B	0H,0H,0H,0H

	DC.B	55H,0AAH

	END
