80286.TAB
	motorola

	segment	byte at 0600 'code'
; Excut en 0000:7C00
	cli
	xor	ax,ax	;Met SS=ES=DS=$0000
	mov	ss,ax
	mov	sp,$7C00	;SS:SP = 0000:7C00
	mov	si,sp	;DS:SI = 0000:7C00
	push	ax
	pop	es
	push	ax
	pop	ds
	sti

	cld		;Copie le secteur en $0600:0000
	mov	di,$0600
	mov	cx,$0100
	repne
	movsw
	jmpf	Suite	;et y passe la main

; Excut en 0000:0600
Suite:
	mov	si,Partition1	;Pointe premire partition
	mov	bl,$4	;Pour 4 partitions
P_Suiv:
	cmp	ds:[si],$80
	je	P_Active
	cmp	ds:[si],$00
	jne	P_Erronee
	add	si,16
	dec	bl
	jne	P_Suiv

	int	$18	;Pas de partition valide, appel basic en Rom !

;--- Trouv une partition active
P_Active:
	mov	dx,ds:[si]	;dl=$80 dh=tte dbut partition
	mov	cx,ds:2[si]	;cx=sect+cyl dbut partition
	mov	bp,si		;bp=@table partition de boot
BcleVerif:
	add	si,16		;Vrifie que seule partition active
	dec	bl
	je	LoadBoot
	cmp	ds: [si],$0
	je	BcleVerif

;--- Code type partition erron (ni 0:inactive, ni 80:active)
P_Erronee:
	mov	si,TxtP_Inv
BcleAffMsg:
	lodsb		;Rcupre un car du message DS:SI
	cmp	al,0	;Fin du message : termine
	je	BcleStop

	push	si	;Envoie caractre sur console
	mov	bx,$07	;attribut ?
	mov	ah,$0E	;criture 1 car dans al
	int	$10
	pop	si
	jmps	BcleAffMsg
BcleStop:
	jmps	BcleStop
;---
LoadBoot:
	mov	di,$0005	;5 essais avant de dclarer forfait
BcleLoad:
	mov	bx,$7C00	;ES:BX=Adresse du buffer
	mov	ax,$0201	;Lire 1 secteur
	push	di	;lecteur dl (=$80: premier disque dur)
	int	$13	;tte dh, piste ch, secteur cl
	pop	di	;??? sauvegarde di inutile !
	jnc	LoadOk

	xor	ax,ax	;Initialise disque dur
	int	$13
	dec	di
	jne	BcleLoad

	mov	si,TxtErrLd	;Erreur de chargement secteur boot
	jmps	BcleAffMsg

;--- chargement OK, vrifie secteur correct avant de passer la main
LoadOk:
	mov	si,TxtNoSys	;Vrifie prsence indicateur $55AA
	mov	di,$7DFE
	cmp	ds:[di],$AA55
	jne	BcleAffMsg
	mov	si,bp		;Fournit pointeur sur table partition
	jmpf	$7C00		;Passe le contrle au secteur de boot

TxtP_Inv:	STRING	"Table de partition non valide",0
TxtErrLd:	STRING	"Erreur au cours du chargement du systme d'exploitation",0
TxtNoSys:	STRING	"Systme d'exploitation absent",$0

	segment	byte at 07BE 'code'
Partition1:
	DC.B	$80	;Partition active
	DC.B	$1	;Commence avec tte 1
	DC.W	$0001	;Cyl 0, sect 1
	DC.B	$6	;de type dos 4.0, fat 16 bits
	DC.B	$3F	;termine tte 63
	DC.W	$3860	;sect 32, cyl 312($0138)
	DC.L	$00000020	;32 secteurs entre table et dbut partition
	DC.L	$0009C7E0	;640992 secteurs dans partition
Partition2:
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
Partition3:
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
Partition4:
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
	DC.B	$0,$0,$0,$0
Controle:
	DC.B	$55,$AA

	END
